//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "about.h"
#include "mapunit.h"
#include "xFiles.hpp"
#include "tileunit.h"
#include "sprite.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// weɨϥΪpɾ, C 10 @Is@
void __fastcall TMainForm::tmrTitleTimer(TObject *Sender)
{
  if (!Active) return;

  // ʩZJΤlu
  MoveTanks();
  MoveBullets();

  UpdateView(); // se
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateView()
{
  DrawBackBitmap(); // eb bitmap
  pbxView->Canvas->Draw(0, 0, FBackBitmap); // AeW
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::pbxViewPaint(TObject *Sender)
{
  UpdateView();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  util_init(); // it must be called before everything

  randomize(); // üƺؤl

  FTank = new TMyTank;
  try {
    FTank->LoadBits(); // ŪJDϧ

    TTiles::Instance().LoadFromFile(AppDir + FN_TILE_ARCHIVE); // ŪJϮw
  } catch(Exception& E) {
    ShowMessage(E.Message);
    PostMessage(Handle, WM_CLOSE, 0, 0); // H asynchronous 覡
  }

  // ھڱ`ƨӽվ pnlView εjp
  pnlView->ClientWidth = WORLD_WIDTH;
  pnlView->ClientHeight = WORLD_HEIGHT;

  ClientWidth = pnlView->Width;
  ClientHeight = pnlView->Height;

  FBackBitmap = new Graphics::TBitmap; // wĥ bitmap
  FBackBitmap->Width = WORLD_WIDTH;
  FBackBitmap->Height = WORLD_HEIGHT;

  // wƤu@nF, iJ title e
  GameStatus = gsTitle;
}
//---------------------------------------------------------------------------
// Neøsbwĥ bitmap, AƻsW
void __fastcall TMainForm::DrawBackBitmap()
{
  TMap& Map = TMap::Instance();
  
  if (mnuDrawLayer1->Checked)
    Map.Draw(FBackBitmap->Canvas, LAYER_TERR); // øsaμh
  else { // YSeaμh, N
    FBackBitmap->Canvas->Brush->Color = clBlack;
    FBackBitmap->Canvas->FillRect(FBackBitmap->Canvas->ClipRect);
  }

  if (mnuDrawLayer2->Checked) // øsaΪh
    Map.Draw(FBackBitmap->Canvas, LAYER_TERRITEM);

  if (mnuDrawLayer3->Checked) // øs~h
    Map.Draw(FBackBitmap->Canvas, LAYER_ITEM);

  // Y_, eX_
  if (Gem) Gem->Draw(FBackBitmap->Canvas);

  DrawTanks(FBackBitmap->Canvas, false); // eXaWҦZJ

  DrawBullets(FBackBitmap->Canvas); // eXlu

  if (mnuDrawLayer4->Checked) // øsaΪh
    Map.Draw(FBackBitmap->Canvas, LAYER_HITERRITEM);

  // eX"Ť"ҦZJ
  DrawTanks(FBackBitmap->Canvas, true);

  FBackBitmap->Canvas->Font->Color = clWhite;
  FBackBitmap->Canvas->Font->Name = "FixedSys";
  FBackBitmap->Canvas->Font->Style = TFontStyles() << fsBold;
  FBackBitmap->Canvas->Font->Size = 14;
  FBackBitmap->Canvas->Brush->Style = bsClear;

  TRect R;
  switch (FGameStatus) {
    case gsTitle:
      // eXWDjrΤU誺@̦W
      R = Rect(0, 0, TILE_WIDTH * TILE_NUM_X, TILE_HEIGHT * TILE_NUM_Y - FBackBitmap->Canvas->TextHeight("") / 2);
      DrawText(FBackBitmap->Canvas->Handle, "@: eF", - 1, &R, DT_BOTTOM | DT_CENTER | DT_SINGLELINE);
      DrawStatusBox("w{ ZJjM", true);
      break;

     case gsOver: // Ouch, xXQFΥDF
        DrawStatusBox("ȥ", false);
      break;

    default:
        // bkWܥͩROΤ
        AnsiString Str = Format("˥ %.2d o %.4d", OPENARRAY(TVarRec,
          (FTank->HP, FScore)));
        FBackBitmap->Canvas->TextOut(WORLD_WIDTH - FBackBitmap->Canvas->TextWidth(Str) - 5, 5, Str);

        // bWd
        Str = Format("LEVEL %d", OPENARRAY(TVarRec, (FLevelNo)));
        FBackBitmap->Canvas->TextOut(5, 5, Str);

      break;
  }

  // oOLe
  if (FGameStatus == gsSuccess)
    DrawStatusBox("Ȧ\ !!", false);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetGameStatus(TGameStatus Value)
{
  FGameStatus = Value;

  // ھڷsCA}pɾ
  tmrTitle->Enabled = FGameStatus == gsTitle;

  switch (FGameStatus) {
    case gsTitle:
      LevelNo = 1; // weܲĤ@a

      // H MAX_TANK_ON_SCREEN ĤZJ
      for (int i = 1; i <= MAX_TANK_ON_SCREEN; i++)
        CreateETank(random(5) + 1);

      FTank->Visible = false; // NۤvZJð_
      FTank->Active = false; // ۤvZJn
      break;

    case gsPlaying:
      UpdateControlStatus(); // sDCΨ䥦
      UpdateView(); // sCe

      GameLoop(); // iJCDj (Ci椤@bj餺)
      break;

    case gsSuccess:
      break;
  }

  if (FGameStatus != gsTerminate) { // ϥΪ̬O_ ??
    UpdateControlStatus(); // sDCΨ䥦
    UpdateView(); // sCe
  } else
    Close(); // 
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetLevelNo(int Value)
{
  TMap& Map = TMap::Instance();
  
  Map.LevelNo = Value; // Jda
  FTank->PosX = Map.Role_X; // ND\bdwm
  FTank->PosY = Map.Role_Y;

  FLevelNo = Value;
  
  UpdateControlStatus();
  UpdateView();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateControlStatus()
{
  const AnsiString StatusStr[5] = {"Welcome", "", "Ȧ\ !!", "Game Over", "Terminating"};

  if (FGameStatus != gsPlaying)
    Caption = Format("%s - %s", OPENARRAY(TVarRec, (Application->Title, StatusStr[(int)FGameStatus])));
  else
    Caption = Format("%s -  %d", OPENARRAY(TVarRec, (Application->Title, FLevelNo)));

  // }UPબA
  mnuRestart->Enabled = FGameStatus == gsPlaying;
  mnuStartGame->Enabled = FGameStatus != gsPlaying;

  mnuPrevLevel->Enabled = FGameStatus == gsPlaying && LevelNo > 1;
  mnuNextLevel->Enabled = FGameStatus == gsPlaying;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DrawStatusBox(AnsiString S, bool TopOrCenter)
{
  FBackBitmap->Canvas->Font->Color = clWhite; // r
  FBackBitmap->Canvas->Font->Name = "FixedSys";
  FBackBitmap->Canvas->Font->Style = TFontStyles() << fsBold;
  FBackBitmap->Canvas->Font->Size = 20;

  TSize TextSize = FBackBitmap->Canvas->TextExtent(S);
  // first calculate the necessary rectangle
  TRect R = Rect(0, 0, TextSize.cx, TextSize.cy);
  OffsetRect(&R, (FBackBitmap->Width - TextSize.cx) / 2, (FBackBitmap->Height - TextSize.cy) / 2); // Nخظme

  if (TopOrCenter) {
    R.Top = 20; // Nخ\bW褤
    R.Bottom = R.Top + TextSize.cy;
  }

  InflateRect(&R, 10, 10); // yø~, e׬ 10
  FBackBitmap->Canvas->Pen->Width = 4;
  FBackBitmap->Canvas->Pen->Color = clWhite;
  FBackBitmap->Canvas->Pen->Style = psSolid;
  FBackBitmap->Canvas->Brush->Color = clBlue;
  FBackBitmap->Canvas->Brush->Style = bsSolid;
  FBackBitmap->Canvas->Rectangle(R.Left, R.Top, R.Right, R.Bottom);

  // NreX, m
  DrawText(FBackBitmap->Canvas->Handle, S.c_str(), S.Length(), &R, DT_CENTER | DT_SINGLELINE | DT_VCENTER);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::mnuStartGameClick(TObject *Sender)
{
  LevelNo = LevelNo;
  GameStatus = gsPlaying;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuRestartClick(TObject *Sender)
{
  LevelNo = LevelNo;
  PostMessage(0, WM_INIT_LEVEL, 0, 0); // s}ld
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if (FGameStatus == gsPlaying) { // `N, uCA, L~
    switch (Key) {
      case VK_UP: case VK_DOWN: case VK_LEFT: case VK_RIGHT:
        switch (Key) {
          case VK_UP: FTank->Direction = drUp; break; // VW

          case VK_DOWN: FTank->Direction = drDown; break; // VU

          case VK_LEFT: FTank->Direction = drLeft; break; // V

          case VK_RIGHT: FTank->Direction = drRight; break; // Vk
        }

        FTank->Active = true; // D}l""
        break;

      case VK_SPACE:
        FTank->FireBullet(); // oglu,  ~~
      break;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuAboutClick(TObject *Sender)
{
  TAboutBox* box = new TAboutBox(this);
  try {
    box->ShowModal();
  } __finally {
    delete box;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuChooseLevelClick(TObject *Sender)
{
  AnsiString S = IntToStr(FLevelNo);
  if (InputQuery(Application->Title, "Input Scenario No:", S)) {
    LevelNo = StrToInt(S);

    if (GameStatus != gsPlaying)
      GameStatus = gsPlaying;
    else
      PostMessage(0, WM_INIT_LEVEL, 0, 0); // }ld
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuPrevLevelClick(TObject *Sender)
{
  switch (dynamic_cast<TComponent*>(Sender)->Tag) {
    case 0: LevelNo = LevelNo - 1; break;
    case 1: LevelNo = LevelNo + 1; break;
  }
  PostMessage(0, WM_INIT_LEVEL, 0, 0); // }lsd
}
//---------------------------------------------------------------------------
// ͼĤZJ
void __fastcall TMainForm::CreateETank(int Kind)
{
  FETankUsed++; // WdwͪĤZJ

  TETank* T;
  T = new TETank(Kind);
  T->LoadBits();
}

//---------------------------------------------------------------------------
// _
void __fastcall TMainForm::CreateGem(int Kind)
{
  Gem = new TGem(TGemKind(Kind));
  Gem->LoadBits();
  Gem->RandomPosition(); // HN\m
  // _X{ 30 ۰ʮ
  SetTimer(Handle, TIMER_ID_GEM, 30 * 1000, NULL);
}
//---------------------------------------------------------------------------
// d}lelʧ@
void __fastcall TMainForm::InitLevel()
{
  FScore = 0;
  FETankUsed = 0;

  // DX{, 
  FTank->Visible = true;
  FTank->Active = false;
  FTank->Speed = MYTANK_DEFAULT_SPEED;
  FTank->ResetStatus();

#ifdef DEBUG // ծD
  FTank->MaxBulletNum = 100;
  FTank->HP = 100;
#endif

  // ثeﶵ]wZJA
  FTank->SuperMode = mnuSuperMode->Checked; // LļҦ
  if (mnuUnlimitedBullet->Checked) // solu
    FTank->MaxBulletNum = 100;
  else
    FTank->MaxBulletNum = 1;

  // N{slu, ĤZJ_
  FreeBullets();
  FreeTanks();
  if (Gem) delete Gem;

  // nȰĤH
  FEnemyStopped = false;

  // NҦpɾ
  KillTimer(Handle, TIMER_ID_GEM);
  KillTimer(Handle, TIMER_ID_GEM_HAT);
  KillTimer(Handle, TIMER_ID_GEM_HAT);
  KillTimer(Handle, TIMER_ID_GEM_ARROW);
}

void __fastcall TMainForm::GameLoop()
{
  InitLevel(); // l

  TMsg Msg;
  int iStopTime;
  TSprite* Sprite;
  TMap& Map = TMap::Instance();

  // Cj
  while (FGameStatus == gsPlaying) {
    if (PeekMessage(&Msg, 0, 0, 0, PM_REMOVE)) { // oT
      switch (Msg.message) {
        case WM_QUIT: // {, }Cj
          FGameStatus = gsTerminate;
          goto OutGameLoop;

        case WM_DESTROY_OBJECT: // nDY
          Sprite = (TSprite*)Msg.wParam;

          if (Sprite == FTank) { // YOD
            FTank->Visible = false;
            FGameStatus = gsOver; // Game over o ~~
            goto OutGameLoop; // }Cj
          }

          // ZJRnSOBz
          if (dynamic_cast<TTank*>(Sprite)) {

            // YQROĤZJ, h Msg.LPARAM N
            FScore += Msg.lParam;

            // NZJPP䦳YluѰY
            FreeBulletsForTank(dynamic_cast<TTank*>(Sprite));

            // YĤZJX{BF, hU@h
            if (FETankUsed == MAX_ETANK_PER_SCENARIO && Tanks()->size() == 1) {
              // oӥ[@ǹLe...
              LevelNo = LevelNo + 1;
              InitLevel();
            }
          }

          // 񪫥
          delete Sprite;

         break;

        case WM_GAMEOVER: // xXQF, C
          FGameStatus = gsOver;
          goto OutGameLoop; // }Cj

        case WM_SPECIAL_CONDITION: // iJSA
          iStopTime = 10; // SAw]ĮɶQ

          switch (Msg.wParam) {
            case TIMER_ID_GEM_CLOCK: FEnemyStopped = true;// ȰĤH
            break;

            case TIMER_ID_GEM_HAT: FTank->SuperMode = true; // L
            break;

            case TIMER_ID_GEM_ARROW:
              // bxXP\W}K, B״_
              Map.GetCell(LAYER_TERRITEM, 5, 11).TileNo = 26;
              Map.GetCell(LAYER_TERRITEM, 5, 11).DisposeBreakMap();
              Map.GetCell(LAYER_TERRITEM, 6, 11).TileNo = 26;
              Map.GetCell(LAYER_TERRITEM, 6, 11).DisposeBreakMap();
              Map.GetCell(LAYER_TERRITEM, 7, 11).TileNo = 26;
              Map.GetCell(LAYER_TERRITEM, 7, 11).DisposeBreakMap();
              Map.GetCell(LAYER_TERRITEM, 5, 12).TileNo = 26;
              Map.GetCell(LAYER_TERRITEM, 5, 12).DisposeBreakMap();
              Map.GetCell(LAYER_TERRITEM, 7, 12).TileNo = 26;
              Map.GetCell(LAYER_TERRITEM, 7, 12).DisposeBreakMap();

              iStopTime = 20; // KGQ
            break;
          }
          // ]wpɾ
          SetTimer(Handle, Msg.wParam, iStopTime * 1000, NULL);
        break;

        case WM_TIMER: // pɾɶ (SAɶ)
          KillTimer(Handle, Msg.wParam); // pɾ

          switch (Msg.wParam) {
            case TIMER_ID_GEM: // _\[F, ٤Y, 
              if (Gem) delete Gem;
              break;

            case TIMER_ID_GEM_CLOCK: FEnemyStopped = false;
            break;

            case TIMER_ID_GEM_HAT:
              FTank->SuperMode = mnuSuperMode->Checked;
              break;

            case TIMER_ID_GEM_ARROW: // bxXP\^j
              Map.GetCell(LAYER_TERRITEM, 5, 11).TileNo = 10;
              Map.GetCell(LAYER_TERRITEM, 6, 11).TileNo = 10;
              Map.GetCell(LAYER_TERRITEM, 7, 11).TileNo = 10;
              Map.GetCell(LAYER_TERRITEM, 5, 12).TileNo = 10;
              Map.GetCell(LAYER_TERRITEM, 7, 12).TileNo = 10;
            break;
          }
         break;

        case WM_INIT_LEVEL:
          InitLevel(); // ds}l
          break;
      }

      // `TBz{
      TranslateMessage(&Msg);
      DispatchMessage(&Msg);
    } else if (Focused()) { // Y֦JJI~ʧ@
      // YdΥثeĤZJSFW,
      // hӶü"i"X{ĤZJ

      if (FETankUsed < MAX_ETANK_PER_SCENARIO &&
        (int)Tanks()->size() < MAX_TANK_ON_SCREEN &&
        random(100) < 100 * PROBAB_ETANK_BORN)
        CreateETank(random(5) + 1); // ةZJ@

      // YثeS_, hӶü"i"X{_
      if (!Gem && random(100) < 100 * PROBAB_GEM_BORN)
        CreateGem(random(6)); // _@

      // ʧڤZJΡμĤZJ
      if (FEnemyStopped)
        FTank->Move();
      else
        MoveTanks();

      // ʤlu
      MoveBullets();

      // se
      UpdateView();
    } else {
      // YSoJJI, hNv浹䥦,
      // 즳Ti
      WaitMessage();
    }
  }

  OutGameLoop: ;
}

void __fastcall TMainForm::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  // `N, uCA, L~
  if (FGameStatus == gsPlaying)
    switch (Key) { // }L, ڤZJNʧ@
      case VK_UP: case VK_DOWN: case VK_LEFT: case VK_RIGHT:
      FTank->Active = false;
      break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuSuperModeClick(TObject *Sender)
{
  TMenuItem* item = (TMenuItem*)Sender;
  item->Checked = !item->Checked;

  switch (item->Tag) {
    case 0: FTank->SuperMode = item->Checked; // LļҦ
    break;

    case 1:
      if (item->Checked) // solu
        FTank->MaxBulletNum = 100;
      else
        FTank->MaxBulletNum = 1;
      break;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuDrawLayerClick(TObject *Sender)
{
  TMenuItem* item = dynamic_cast<TMenuItem*>(Sender);
  
  item->Checked = !item->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::mnuExitClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormActivate(TObject *Sender)
{
/*  LevelNo = 1;
  GameStatus = gsPlaying;
  */
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  // Ҧ귽
  delete FTank;
  FreeTanks();
  FreeBullets();

  delete FBackBitmap;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::ApplicationEvents1Message(tagMSG &Msg,
      bool &Handled)
{
  if (Msg.message == WM_DESTROY_OBJECT) {
    TSprite* Sprite = (TSprite*)Msg.wParam;

    // 񪫥
    delete Sprite;
  }
}
//---------------------------------------------------------------------------

